searchData={"items":[{"type":"module","title":"Hardhat","doc":"An opinionated, production-ready HTTP client for Elixir services.","ref":"Hardhat.html"},{"type":"module","title":"What's included - Hardhat","doc":"- [X] Connection pooling per-client module\n- [X] Integration with `telemetry` and `opentelemetry` instrumentation\n- [X] Circuit breaking for repeatedly failed requests\n- [X] Timeout and `deadline` support\n- [X] Automatic retries for failed requests","ref":"Hardhat.html#module-what-s-included"},{"type":"function","title":"Hardhat.child_spec/1","doc":"","ref":"Hardhat.html#child_spec/1"},{"type":"function","title":"Hardhat.deadline_propagation_opts/0","doc":"","ref":"Hardhat.html#deadline_propagation_opts/0"},{"type":"function","title":"Hardhat.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#delete/3"},{"type":"function","title":"Hardhat.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#delete!/3"},{"type":"function","title":"Hardhat.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#get/3"},{"type":"function","title":"Hardhat.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#get!/3"},{"type":"function","title":"Hardhat.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#head/3"},{"type":"function","title":"Hardhat.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#head!/3"},{"type":"function","title":"Hardhat.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#options/3"},{"type":"function","title":"Hardhat.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#options!/3"},{"type":"function","title":"Hardhat.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#patch/4"},{"type":"function","title":"Hardhat.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#patch!/4"},{"type":"function","title":"Hardhat.pool_options/1","doc":"","ref":"Hardhat.html#pool_options/1"},{"type":"function","title":"Hardhat.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#post/4"},{"type":"function","title":"Hardhat.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#post!/4"},{"type":"function","title":"Hardhat.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#put/4"},{"type":"function","title":"Hardhat.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Hardhat.html#put!/4"},{"type":"function","title":"Hardhat.request/2","doc":"Perform a request.","ref":"Hardhat.html#request/2"},{"type":"function","title":"Options - Hardhat.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Hardhat.html#request/2-options"},{"type":"function","title":"Examples - Hardhat.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Hardhat.html#request/2-examples"},{"type":"function","title":"Hardhat.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Hardhat.html#request!/2"},{"type":"function","title":"Hardhat.should_melt/1","doc":"","ref":"Hardhat.html#should_melt/1"},{"type":"function","title":"Hardhat.should_regulate/1","doc":"","ref":"Hardhat.html#should_regulate/1"},{"type":"function","title":"Hardhat.should_retry/1","doc":"","ref":"Hardhat.html#should_retry/1"},{"type":"function","title":"Hardhat.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#trace/3"},{"type":"function","title":"Hardhat.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Hardhat.html#trace!/3"},{"type":"type","title":"Hardhat.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Hardhat.html#t:option/0"},{"type":"module","title":"Hardhat.Defaults","doc":"Contains default implementations of functions that can be overridden in\nclients that `use Hardhat`.","ref":"Hardhat.Defaults.html"},{"type":"function","title":"Hardhat.Defaults.deadline_propagation_opts/0","doc":"Default implementation of the options to `Hardhat.Middleware.DeadlinePropagation` that\nis included in the default middleware stack.\n\nThese defaults include:\n- `:header` - `\"deadline\"` is the name of the header added to the request","ref":"Hardhat.Defaults.html#deadline_propagation_opts/0"},{"type":"function","title":"Hardhat.Defaults.fuse_opts/1","doc":"Default implementation of the options to the `Tesla.Middleware.Fuse` that is\nincluded in the default middleware stack.\n\nTakes the client module name as an argument.\n\nThese defaults include:\n- `:opts` - The fuse will blow after 50 errors with 1 second, and reset after 2 seconds\n- `:keep_original_error` - The original error will be returned when a fuse first blows\n- `:should_melt` - The `should_melt/1` function defined in the client module is used\n   (by default this is `Hardhat.Defaults.should_melt/1`)\n- `:mode` - The fuse uses `:async_dirty` mode to check the failure rate, which may result\n  in some delay in blowing the fuse under high concurrency, but it will not serialize\n  checks to the fuse state through a single process\n\nSee `Tesla.Middleware.Fuse` for more information on how to configure the middleware.","ref":"Hardhat.Defaults.html#fuse_opts/1"},{"type":"function","title":"Hardhat.Defaults.pool_options/1","doc":"The default options for the connection pool that will be created when your\nclient is added to the supervision tree.\n\nThis creates a connection pool of size `10`.","ref":"Hardhat.Defaults.html#pool_options/1"},{"type":"function","title":"Hardhat.Defaults.regulator_opts/1","doc":"Default options for the `Regulator` middleware, which can be used as an\nalternative circuit-breaking strategy to `fuse`.\n\nThe defaults include:\n* `:min_limit` - The minimum concurrency limit (defaults to 5)\n* `:initial_limit` - The initial concurrency limit when the regulator is installed (deafults to 20)\n* `:max_limit` - The maximum concurrency limit (defaults to 200)\n* `:step_increase` - The number of tokens to add when regulator is increasing the concurrency limit (defaults to 10).\n* `:backoff_ratio` - Floating point value for how quickly to reduce the concurrency limit (defaults to 0.9)\n* `:target_avg_latency` - This is the average latency in milliseconds for the system regulator is protecting. If the average latency drifts above this value Regulator considers it an error and backs off. Defaults to 5.\n* `:should_regulate` - Whether to consider the result of the request as failed, defaults to `should_regulate/1`.","ref":"Hardhat.Defaults.html#regulator_opts/1"},{"type":"function","title":"Hardhat.Defaults.retry_opts/1","doc":"Default implementation of the options to `Tesla.Middleware.Retry` that is\nincluded in the default middleware stack.\n\nThese defaults include:\n- `:delay` - The base delay in milliseconds (positive integer, defaults to 50)\n- `:max_retries` - maximum number of retries (non-negative integer, defaults to 3)\n- `:max_delay` - maximum delay in milliseconds (positive integer, defaults to 300)\n- `:should_retry` - function to determine if request should be retried, defaults to `should_retry/1`\n- `:jitter_factor` - additive noise proportionality constant (float between 0 and 1, defaults to 0.2)","ref":"Hardhat.Defaults.html#retry_opts/1"},{"type":"function","title":"Hardhat.Defaults.should_melt/1","doc":"Default implementation of the \"melt test\" for circuit breaking. This\nfunction will cause the circuit breaker to record an error when the\nresult of a request is:\n\n* A TCP-level error, e.g. `{:error, :econnrefused}`\n* An HTTP status that indicates a server error or proxy-level error (>= 500)\n* An `429 Too Many Requests` HTTP status","ref":"Hardhat.Defaults.html#should_melt/1"},{"type":"function","title":"Hardhat.Defaults.should_regulate/1","doc":"Default implementation of the \"failure test\" for dynamic regulation. This\nfunction will cause the `Regulator` to record an error when the\nresult of a request is:\n\n* A TCP-level error, e.g. `{:error, :econnrefused}`\n* An HTTP status that indicates a server error or proxy-level error (>= 500)\n* An `429 Too Many Requests` HTTP status","ref":"Hardhat.Defaults.html#should_regulate/1"},{"type":"function","title":"Hardhat.Defaults.should_retry/1","doc":"Default implementation of the \"retry test\" for retries. This\nfunction will cause requests to be retried when the result of the\nrequest is:\n\n* A TCP-level error, e.g. `{:error, :econnrefused}`\n* An HTTP status that indicates a server error or proxy-level error (>= 500)\n* An `429 Too Many Requests` HTTP status\n\nIn the case where the circuit breaker has been triggered, requests will\nnot be retried.","ref":"Hardhat.Defaults.html#should_retry/1"},{"type":"module","title":"Hardhat.Middleware.DeadlinePropagation","doc":"Propagates `Deadline` information across the request to the\nserver being called.","ref":"Hardhat.Middleware.DeadlinePropagation.html"},{"type":"module","title":"Hardhat.Middleware.PathParams","doc":"Use templated URLs with separate params. Unlike `Tesla.Middleware.PathParams`,\nwe ensure that all parameters are URL-safe.","ref":"Hardhat.Middleware.PathParams.html"},{"type":"module","title":"Hardhat.Middleware.Regulator","doc":"","ref":"Hardhat.Middleware.Regulator.html"},{"type":"module","title":"Hardhat.Middleware.Timeout","doc":"","ref":"Hardhat.Middleware.Timeout.html"},{"type":"function","title":"Hardhat.Middleware.Timeout.call/3","doc":"Timeout HTTP request after X milliseconds.\n\nIncludes:\n- automatic propagation of OpenTelemetry tracing context\n- addition of OpenTelemetry span events when the timeout is exceeded\n\nOptions:\n- `:timeout` - (required) timeout in milliseconds","ref":"Hardhat.Middleware.Timeout.html#call/3"},{"type":"module","title":"Hardhat.Sup","doc":"","ref":"Hardhat.Sup.html"},{"type":"function","title":"Hardhat.Sup.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hardhat.Sup.html#child_spec/1"},{"type":"function","title":"Hardhat.Sup.init/1","doc":"","ref":"Hardhat.Sup.html#init/1"},{"type":"function","title":"Hardhat.Sup.start_link/1","doc":"","ref":"Hardhat.Sup.html#start_link/1"}],"content_type":"text/markdown"}